/*
 * Copyright (c) 1986-1992, 1998, 1999 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)rpcbind.h	1.14	99/12/14 SMI; TSOL 2.x"

/*
 * rpcbind.h
 * The common header declarations
 */

#ifndef rpcbind_h
#define	rpcbind_h

#ifdef PORTMAP
#include <rpc/pmap_prot.h>
#endif
#include <rpc/rpcb_prot.h>
#ifdef TSOL
#include <rpc/tsolrpcb_prot.h>
#endif /* TSOL */

extern int debugging;
extern int doabort;
#ifdef TSOL
extern tsol_rpcblist_ptr list_rbl; /* List of version 3 & 4 rpcbind services */
#else /* TSOL */
extern rpcblist_ptr list_rbl;	/* A list of version 3 & 4 rpcbind services */
#endif /* TSOL */
extern char *loopback_dg;	/* CLTS loopback transport, for set/unset */
extern char *loopback_vc;	/* COTS loopback transport, for set/unset */
extern char *loopback_vc_ord;	/* COTS_ORD loopback transport, for set/unset */

#ifdef PORTMAP
#ifdef TSOL
extern tsol_pmaplist *list_pml;	/* A list of version 2 rpcbind services */
#else /* TSOL */
extern pmaplist *list_pml;	/* A list of version 2 rpcbind services */
#endif /* TSOL */
extern char *udptrans;		/* Name of UDP transport */
extern char *tcptrans;		/* Name of TCP transport */
extern char *udp_uaddr;		/* Universal UDP address */
extern char *tcp_uaddr;		/* Universal TCP address */
#endif

extern char *mergeaddr();
extern int add_bndlist();
extern int create_rmtcall_fd();
extern bool_t is_bound();
extern void my_svc_run();

/* Statistics gathering functions */
extern void rpcbs_procinfo();
extern void rpcbs_set();
extern void rpcbs_unset();
extern void rpcbs_getaddr();
extern void rpcbs_rmtcall();
extern rpcb_stat_byvers *rpcbproc_getstat();

extern struct netconfig *rpcbind_get_conf();
extern void rpcbind_abort();

/* Common functions shared between versions */
extern void rpcbproc_callit_com();
extern bool_t *rpcbproc_set_com();
extern bool_t *rpcbproc_unset_com();
extern u_long *rpcbproc_gettime_com();
extern struct netbuf *rpcbproc_uaddr2taddr_com();
extern char **rpcbproc_taddr2uaddr_com();
extern char **rpcbproc_getaddr_com();

/* For different getaddr semantics */
#define	RPCB_ALLVERS 0
#define	RPCB_ONEVERS 1

#ifdef TSOL

/* RPCBIND STARTUP */
extern void tsol_rpcbind_start_check(void);

/* RPCBIND PROCEDURES */

#define	TSOL_SKIP_MLMS 0
#define	TSOL_DO_MLMS 1

#define	TSOL_EXTERNAL 0
#define	TSOL_INTERNAL 1

extern char **tsol_rpcbproc_dump(RPCB *regp, struct svc_req *rastp,
    SVCXPRT *transp);
extern char **tsol_pmaplist_dump(struct svc_req *rastp,
    SVCXPRT *transp);
extern char **tsol_rpcbproc_dumpall(RPCB *regp, struct svc_req *rastp,
    SVCXPRT *transp);
extern void tsol_free_rpcblist(char *result);
extern void tsol_free_pmaplist(char *result);
extern void tsol_free_tsol_rpcblist(char *result);
extern void tsol_alloc_attrs(SVCXPRT *handlep);
extern void tsol_reset_bind_state(int mlm_flag, bslabel_t *slp, int out_fd);
extern void tsol_svc_sendreply(SVCXPRT *transp, xdrproc_t xdr_rmtcall_result,
    char *a);
extern void tsol_whoami_chstate(SVCXPRT *xprt, u_long prog);
extern int tsol_svc_set_reply_sl(SVCXPRT *xprt);
extern int tsol_get_incoming_attrs(SVCXPRT *transp, bslabel_t **slpp,
    priv_set_t **prvpp);
extern int tsol_t_sndudata(int fd, struct t_unitdata *tu_data,
    SVCXPRT *transp);
extern int tsol_t_bind(int fd, register struct t_bind *req,
    register struct t_bind *ret);
extern int tsol_set_bind_state(int mlm_flag, bslabel_t *slp, int out_fd);
extern int tsol_privport_chk(char *netid, char *uaddr, priv_set_t *privp);

#endif /* TSOL */

#endif /* rpcbind_h */
